<template>
  <div id="app">
    <button @click.prevent="toggleMenu()" class="x x-fixed">
      {{ isVisible ? "hide" : "show" }}
    </button>
    <!-- <button @click.prevent="handleLogOut()" class="x x-fixed-2">log-out</button> -->
    <transition-group name="move-rest">
      <div class="nav" v-bind:key="test">
        <transition
          name="nav-links"
          type="transition"
          mode="in-out"
          :key="test"
        >
          <nav
            id="nav"
            v-if="isVisible"
            :class="isVisible ? 'is-visible' : 'not-visible'"
          >
            <!-- <button @click.prevent="toggleMenu()" class="x x-in-row">X</button> -->
            <router-link to="/">Home</router-link> |
            <router-link to="/clock">
              <span>Clock</span>
            </router-link>
            |
            <router-link to="/first-ToDo">1st ToDo</router-link> |
            <router-link to="/wisielec">Wisielec</router-link> |
            <router-link to="/uczonko">
              <span @click="elo()">Uczonko</span>
            </router-link>
            |
            <router-link to="/uczonko-vuex">
              <span>Vuex kurde</span>
            </router-link>
            <!-- |
            <router-link to="/show-keycloak-obect">Keycloak-obj</router-link>
            | -->
          </nav>
        </transition>
      </div>
      <div class="rest" v-bind:key="test2">
        <transition name="fade-el">
          <router-view />
        </transition>
      </div>
    </transition-group>
  </div>
</template>

<script>
import Keycloak from "keycloak-js";

export default {
  mounted() {
    // this.login();
    // console.log(process.env);
  },
  data() {
    return {
      isVisible: true,
      test: "test",
      test2: "test2",
      move: "move",
    };
  },
  methods: {
    oldLogOut() {
      console.log(this.keycloak);
      this.keycloak.logout({
        redirectUri: `${process.env.VUE_APP_BASE_APP_URL}`,
      });
    },
    elo() {
      console.log("yo: ", this.$route);
      console.log("yo: ", this.$route.fullPath);
    },
    toggleMenu() {
      this.isVisible = !this.isVisible;
    },
    //  KEYCLOAK FN
    handleLogOut() {
      const MY_REALM = "test";
      const ENCODED_REDIRECT_URI = "https://fantastic-app.mac.pl:8081";
      window.location.replace(
        `${process.env.VUE_APP_BASE_KEYCLOAK_URL}realms/${MY_REALM}/protocol/openid-connect/logout?redirect_uri=${ENCODED_REDIRECT_URI}`
      );
    },
    login() {
      var keycloak = Keycloak({
        realm: `test`,
        url: `${process.env.VUE_APP_BASE_KEYCLOAK_URL}`,
        clientId: `fantastic-app`,
        "ssl-required": "all",
        resource: `fantastic-app`,
        "public-client": true,
        "confidential-port": 0,
      });
      keycloak
        .init({
          promiseType: "native",
          onLoad: "login-required",
        })
        .then((authenticated) => {
          this.$store.commit("TOKEN_SET", authenticated);
          console.log("TOKEN", authenticated);
          return authenticated;
        })
        .catch((error) => {
          console.error(error);
        });
      keycloak.onTokenExpired = () => {
        keycloak
          .updateToken(30)
          .then((refreshed) => {
            if (refreshed) {
              this.$store.commit("TOKEN_SET", keycloak.token);
            } else {
              console.log("Token is still valid");
            }
          })
          .catch((error) => {
            console.error(error);
          });
      };
    },
  },
  computed: {
    keycloakToken() {
      return this.$store.getters.keycloakToken;
    },
  },
  provide() {
    return {
      login: this.login,
      handleLogOut: this.handleLogOut,
    };
  },
};
</script>

<style scoped>
* {
  margin: 0;
  padding: 0;
  box-sizing: border-box;
}
#app {
  font-family: Avenir, Helvetica, Arial, sans-serif;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
  text-align: center;
  color: #2c3e50;
  /* min-width: 100vw; */
  /* max-width: 100vw; */
  min-height: 100vh;
  overflow: hidden;
}

nav {
  margin: 0;
  padding: 30px;
}

nav a {
  font-weight: bold;
  color: #2c3e50;
}

nav a.router-link-exact-active {
  /* color: #42b983; */
  color: #3a0061;
}
.x {
  margin: 8px;
  padding: 8px;
  cursor: pointer;
  font-weight: bold;
  transition: 0.3s;
  background-color: #edd2ff;
  border: 1px solid #000;
}
.x:hover {
  color: white;
  background-color: #3a0061;
}
.x-fixed {
  position: absolute;
  top: 10px;
  left: 10px;
}

.x-fixed-2 {
  position: absolute;
  top: 10px;
  right: 10px;
}

.is-visible {
  visibility: visible;
}
.not-visible {
  visibility: hidden;
}

/* TRANSITIONS */

.nav-links-enter {
  margin-left: -140vw;
}
.nav-links-enter-active {
  transition: margin-left 1s;
}
.nav-links-leave-to {
  margin-right: -140vw;
}
.nav-links-leave-active {
  transition: margin-right 1s;
}
/* .nav-links-leave {
  margin-right: -100vw;
}
.nav-links-leave-active {
  transition: margin-right 1s;
} */
.move-page-enter {
  margin: auto;
}
.move-page-enter-active {
  transition: 1s;
}
/* .move-page-leave-to {
} */
.move-page-leave-active {
  transition: 1s;
}
.fade-el-enter {
  opacity: 0;
}
.fade-el-enter-active {
  transition: opacity 1.2s;
}
.move-rest-move {
  transition-duration: 1s;
}
</style>
